From 0da67d346a7901b572ac9ec5812634576b315d79 Mon Sep 17 00:00:00 2001
From: zourenyi <zozobreak@163.com>
Date: Wed, 29 Dec 2021 17:33:50 +0800
Subject: [PATCH v4] avcodec/libx264: add warning log when droping picture at 'h264_select_output_frame'

since there is only debug log 'no picture ooo' when droping a picture,
I spent much time to troubleshooting a wrong sps 'num_reorder_frames' param changed by webrtc's 'ParseAndRewriteSps',
FFmpeg keeped silence about this error, so a warning log is much helpfull about this.

Signed-off-by: zourenyi <zozobreak@163.com>
---
 libavcodec/h264_slice.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/libavcodec/h264_slice.c b/libavcodec/h264_slice.c
index c21004df97..f347d8ee1a 100644
--- a/libavcodec/h264_slice.c
+++ b/libavcodec/h264_slice.c
@@ -1533,7 +1533,13 @@ static int h264_select_output_frame(H264Context *h)
             }
         }
     } else {
-        av_log(h->avctx, AV_LOG_DEBUG, "no picture %s\n", out_of_order ? "ooo" : "");
+        if (out_of_order) {
+            av_log(h->avctx, AV_LOG_WARNING,
+                   "drop picture(%c, %d/%" PRId64 ") because out of order\n",
+                   av_get_picture_type_char(out->f->pict_type), out->poc, out->f->pts);
+        } else {
+            av_log(h->avctx, AV_LOG_DEBUG, "no picture\n");
+        }
     }
 
     return 0;
-- 
2.32.0.windows.2

